// 原始数据
const arr = [
  { parentId: '0-1-1', id: '0-1-1-1', name: '浦东' },
  { parentId: '0-1-1', id: '0-1-1-2', name: '浦西' },
  { parentId: '0-1-1-1', id: '0-1-1-1-1', name: '金桥' },
  { parentId: '0-1-1-1', id: '0-1-1-1-2', name: '台儿庄' },
  { parentId: '0-1-1-1', id: '0-1-1-1-3', name: '世纪大道' },
  { parentId: '0-2', id: '0-2-1', name: '洛杉矶' },
  { parentId: '0-2', id: '0-2-2', name: '休斯敦' },
  { parentId: '0-3', id: '0-3-1', name: '伦敦' },
  { parentId: '0-1-1-1-1', id: '0-1-1-1-1-1', name: '同华大厦' },
  { parentId: '-', id: '0', 'name': '世界' },
  { parentId: '0', id: '0-1', name: '中国' },
  { parentId: '0', id: '0-2', name: '美国' },
  { parentId: '0', id: '0-3', name: '英国' },
  { parentId: '0-1', id: '0-1-1', name: '上海' },
  { parentId: '0-1', id: '0-1-2', name: '北京' },
  { parentId: '0-1', id: '0-1-2', name: '杭州' },
  { parentId: 'A-1', id: '0-1-29', name: '杭州' }

]
function deep(array, parentIem) {
  if (!parentIem.children) { parentIem.children = [] }
  for (const item in array.filter(x => x.parentId === parentIem.id)) {
    parentIem.children.push(item)
    deep(array, item)
  }
}
function call() {
  for (const item in arr.filter(x => x.parentId === '-')) {
    deep(arr, item)
  }
}
// call()
// 创建排序函数
function sortArr(arr, root) {
  // 深拷贝一份数据
  var copy = JSON.parse(JSON.stringify(arr))
  // 创建一个存储数据的对象
  var obj = {}
  // 遍历数据，将数据所有数据添加到对象中，key为数据id，value为原数据对象
  copy.forEach((item, index) => {
    obj[item.id] = item
  })
  // 创建一个最终返回的数组
  var res = []
  // 遍历数据开始处理
  copy.forEach(item => {
    // 将root数据添加进res数组， 因为数据使引用类型，子元素数据都会带过来，下面的循环会处理子元素数据
    if (item.parentId === root) {
      res.push(item)
    }
    // 梳理子元素数据
    for (var key in obj) {
      // 当一层元素id 和 二层元素parentId一致，那么，二层遍历的元素就是一层遍历元素的children
      if (item.id === obj[key].parentId) {
        // 处理数据children
        if (item.children) {
          item.children.push(obj[key])
        } else {
          item.children = [obj[key]]
        }
      }
    }
  })
  return res
}
var newArr = sortArr(arr, '-')
console.log(JSON.stringify(newArr))
